
#include "eosTexture.h"
#include "eosEnvironmentMap.h"
#include <math.h>

/// <sumamry>takes the direction of the ray, picks which texture to
/// sample, and then returns the result in float* color</summary>
/// <returns>(void)</returns>
void eosSampleEnvironmentMap(eosEnvironmentMap *env, 
							float dx, float dy, float dz,
							float *color) {
	unsigned char majorAxis;
	if (abs(dx)>abs(dy)) {
		if (abs(dx)>abs(dz)) {
			majorAxis = 0;
		} else {
			majorAxis = 2;
		}
	} else {
		if (abs(dy)>abs(dz)) {
			majorAxis = 1;
		} else {
			majorAxis = 2;
		}
	}

	if (majorAxis == 0) {
		// x-axis
		if (dx>0) {
			dy /= dx;
			dz /= dx;
			dy = 0.5f + dy*0.5f;
			dz = 0.5f + dz*0.5f;
			eosSampleTexture(*(env->xpos), dz, dy, color);
		} else if (dx<0) {
			dy /= -dx;
			dz /= -dx;
			dy = 0.5f + dy*0.5f;
			dz = 0.5f - dz*0.5f;
			eosSampleTexture(*(env->xneg), dz, dy, color);
		}
	} else if (majorAxis == 1) {
		// y-axis
		if (dy>0) {
			dx /= dy;
			dz /= dy;
			dx = 0.5f + dx*0.5f;
			dz = 0.5f + dz*0.5f;
			eosSampleTexture(*(env->ypos), dx, dz, color);
		} else if (dy<0) {
			dx /= -dy;
			dz /= -dy;
			dx = 0.5f + dx*0.5f;
			dz = 0.5f - dz*0.5f;
			eosSampleTexture(*(env->yneg), dx, dz, color);
		}
	} else if (majorAxis == 2) {
		// z-axis
		if (dz>0) {
			dx /= dz;
			dy /= dz;
			dx = 0.5f - dx*0.5f;
			dy = 0.5f + dy*0.5f;
			eosSampleTexture(*(env->zpos), dx, dy, color);
		} else {
			dx /= -dz;
			dy /= -dz;
			dx = 0.5f + dx*0.5f;
			dy = 0.5f + dy*0.5f;
			eosSampleTexture(*(env->zneg), dx, dy, color);
		}
	}
}
