/*
Eos Environment Map - header
2013 - Matt Pierce

	Describes an environment map to be used by the renderer
	when the ray hits no triangle.

TAB WIDTH: 4
*/

#ifndef _EOS_ENVIRONMENT_MAP_H
#define _EOS_ENVIRONMENT_MAP_H

#include "eosTexture.h"

// eosEnvironmentMap
//		A cubic environment map as represented by 6 eosTexture pointers.
struct eosEnvironmentMap {
	eosTexture *		xpos;		// right
	eosTexture *		xneg;		// left
	eosTexture *		ypos;		// top
	eosTexture *		yneg;		// bottom
	eosTexture *		zpos;		// back
	eosTexture *		zneg;		// front
};

void		eosSampleEnvironmentMap(eosEnvironmentMap *env, 
									float dx, float dy, float dz,
									float *color);

#endif // _EOS_ENVIRONMENT_MAP_H