/*
Eos Filters - header
2013 - Matt Pierce

	Filters you can apply to the frame buffer. The developer has full control
	of the frame buffer when using Eos, but these can be a time-saver.

TAB WIDTH: 4
*/

#ifndef _EOS_FILTERS_H
#define _EOS_FILTERS_H

struct eosExposureTracker {
	float minExposure;
	float maxExposure;
	float currentExposure;
	float sampleInterval;
	float lastSample;
	float targetExposure;
	float lastExposure;
	float targetBrightness;
};

void eosFilterExposure(float exposure, float *buff, unsigned int w, unsigned int h);
void eosFilterGamma(float gamma, float *buff, unsigned int w, unsigned int h);
void eosFilterFastGamma(float gamma, unsigned char *buff, unsigned int w, unsigned int h);
void eosFilterFastExposure(float exposure, unsigned char *buff, unsigned int w, unsigned int h);
void eosFilterFastFloatGamma(float gamma, float *buff, unsigned int w, unsigned int h);
void eosFilterFastFloatExposure(float exposure, float *buff, unsigned int w, unsigned int h);
void eosFilterSoften(unsigned int iterations, float strength, float *buff, unsigned int w, unsigned int h);
void eosInitExposureTracker(eosExposureTracker *tracker);
void eosSampleExposure(float *buff, unsigned int w, unsigned int h, eosExposureTracker *tracker);

#endif // _EOS_FILTERS_H