/*
Eos Material - definitions
2013 - Matt Pierce

	Defines the functions outlined in eosMaterial.h

TAB WIDTH: 4
*/

#include <stddef.h>
#include "eosMaterial.h"

/// <summary>Creates a default material. This is mostly so that nobody
/// tries to dereference m.tex</summary>
/// <returns>default material</returns>
eosMaterial eosCreateMaterial() {
	eosMaterial m;
	m.color[0] = m.color[1] = m.color[2] = 0.8f;
	m.color[3] = 1.0f;
	m.specular = m.glossReflection = m.metalicReflection = m.fresnelTerm = 0.0f;
	m.tex = NULL;
	m.texFile = NULL;
	m.castsShadow = true;
	m.unshaded = false;
	return m;
}