/*
Eos Material - header
2013 - Matt Pierce

	Describes the surface properties for a triangle so
	that it can be rendered.

TAB WIDTH: 4
*/

#ifndef _EOS_MATERIAL_H
#define _EOS_MATERIAL_H

#include "eosTexture.h"

// eosMaterial
//		Describes the surface material of a triangle.
struct eosMaterial {
	float				color[4];			// RGB and Alpha in that order
	eosTexture *		tex;				// texture map that may override color (up to renderer)
	char*				texFile;			// a filename (if your texture comes from a file) so you can reload it later
	float				specular;			// intensity of specular reflection
	float				glossReflection;	// intensity of gloss reflection (think a resin-coated surface)
	float				metalicReflection;	// intensity of metalic reflection (think gold jewelry)
	float				fresnelTerm;		// attenuates reflection based on incident angle (auto paint)
	bool				unshaded;			// whether to do diffuse lighting calculation
											// (use this for pre-baked lighting or faux lights)
	bool				castsShadow;		// whether this should cast a shadow
											// (usually for faux lights in front of actual lights)
};

eosMaterial			eosCreateMaterial();

#endif //_EOS_MATERIAL_H
