/*
Eos Triangle Rendering Information - header
2013 - Matt Pierce

	Information used by the renderer to determine
	how to draw the triangle on the screen. This is
	separated out from the information used to trace
	rays so that the renderer can be modified
	independently.

TAB WIDTH: 4
*/

#ifndef _EOS_TRIANGLE_RENDER_INFO_H
#define _EOS_TRIANGLE_RENDER_INFO_H

#include "eosMaterial.h"

// eosTriangleRenderInfo
//		Stores information used in rendering that's not
//		necessarily needed for the basic trace. This is
//		done to allow the user to add to/modify rendering
//		without having to alter how the tree and basic
//		tracing are done.
struct eosTriangleRenderInfo {
	float				n1[3], n2[3], n3[3];		// vertex normals
	float				tc1[2],tc2[2],tc3[2];		// texture coordinates
	unsigned int		tracerGroup;				// used in supersampling edge detection
	eosMaterial *		mat;						// pointer to surface material
};

#endif // _EOS_TRIANGLE_RENDER_INFO_H